package paxos

const (
  NoOpType = "NoOp"
)

const (
  OK = "OK"
  ErrDead = "ErrDead"
  ErrNoKey = "ErrNoKey"
  ErrWrongGroup = "ErrWrongGroup"
	ErrOldRequest = "ErrOldRequest"
	ErrNotReadyYet = "ErrNotReadyYet"
  ErrNoDisk = "ErrNoDisk"
)
type Err string

type PrepareArgs struct {
  SeqNum int
  PropNum int
  SeqMins []int
  //MenciusPtr int
  MenciusPtr map[int]int
  Me int
	Failures map[int64]int
}

type PrepareReply struct {
  OK bool
  AcceptMax int
  AcceptValue interface{}
  PropMax int
  SeqMins []int
  //MenciusPtr int
  MenciusPtr map[int]int
	Me int
  Failures map[int64]int
}

type AcceptArgs struct {
  SeqNum int
  PropNum int
  Val interface{}
  SeqMins []int
  Suggest bool
  //SkipList []int
  SkipList map[int]bool
  //MenciusPtr int
  MenciusPtr map[int]int
	Me int
  Failures map[int64]int
}

type AcceptReply struct {
  OK bool
  PropNum int
  PropMax int
  SeqMins []int
  //SkipList []int
  SkipList map[int]bool
  //MenciusPtr int
  MenciusPtr map[int]int
	Me int
  Failures map[int64]int
}

type DecideArgs struct {
  SeqNum int
  PropNum int
  Val interface{}
  SeqMins []int  
  Suggest bool
  //SkipList []int
  SkipList map[int]bool
  //MenciusPtr int
  MenciusPtr map[int]int
	Me int
  Failures map[int64]int
}

type DecideReply struct {  
  SeqMins []int
  //SkipList []int
  SkipList map[int]bool
  //MenciusPtr int
  MenciusPtr map[int]int
  Me int
  Failures map[int64]int
}

type RecSkipArgs struct {
  //SkipList []int
  SkipList map[int]bool
  //MenciusPtr int
  MenciusPtr map[int]int
  Me int
}

type RecSkipReply struct {
  OK bool
  //MenciusPtr int
  MenciusPtr map[int]int
}

type LearnInstanceArgs struct {
  SeqNum int
}

type LearnInstanceReply struct {
  Val interface{}
}

type RequestDiskArgs struct {
  Requestor string
  DiskPath string
}

type RequestDiskReply struct {
  Err Err
}


func GetNextNum(last int, offset int, mod int) int {
  init := last % mod
  n := (last/mod)*mod
  if init >= offset {
    n += mod + offset
  } else {
    n += offset
  }
  return n
}

const SUGGEST_SEQ = 10
const ALLOWED_LAG = 15
const REVOKE_NUM = 10

